"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _classnames = _interopRequireDefault(require("classnames"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react = _interopRequireWildcard(require("react"));
var _TypeaheadManager = _interopRequireDefault(require("../../core/TypeaheadManager"));
var _useRootClose = _interopRequireDefault(require("../../core/useRootClose"));
var _useTypeahead = _interopRequireDefault(require("../../core/useTypeahead"));
var _ClearButton = _interopRequireDefault(require("../ClearButton"));
var _Loader = _interopRequireDefault(require("../Loader"));
var _Overlay = require("../Overlay");
var _Token = _interopRequireDefault(require("../Token/Token"));
var _TypeaheadInputMulti = _interopRequireDefault(require("../TypeaheadInputMulti"));
var _TypeaheadInputSingle = _interopRequireDefault(require("../TypeaheadInputSingle"));
var _TypeaheadMenu = _interopRequireDefault(require("../TypeaheadMenu"));
var _utils = require("../../utils");
var _propTypes2 = require("../../propTypes");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var propTypes = {
  /**
   * Displays a button to clear the input when there are selections.
   */
  clearButton: _propTypes["default"].bool,
  /**
   * Props to be applied directly to the input. `onBlur`, `onChange`,
   * `onFocus`, and `onKeyDown` are ignored.
   */
  // eslint-disable-next-line react/forbid-prop-types
  inputProps: (0, _propTypes2.checkPropType)(_propTypes["default"].object, _propTypes2.inputPropsType),
  /**
   * Bootstrap 4 only. Adds the `is-invalid` classname to the `form-control`.
   */
  isInvalid: _propTypes["default"].bool,
  /**
   * Indicate whether an asynchronous data fetch is happening.
   */
  isLoading: _propTypes["default"].bool,
  /**
   * Bootstrap 4 only. Adds the `is-valid` classname to the `form-control`.
   */
  isValid: _propTypes["default"].bool,
  /**
   * Callback for custom input rendering.
   */
  renderInput: _propTypes["default"].func,
  /**
   * Callback for custom menu rendering.
   */
  renderMenu: _propTypes["default"].func,
  /**
   * Callback for custom menu rendering.
   */
  renderToken: _propTypes["default"].func,
  /**
   * Specifies the size of the input.
   */
  size: _propTypes2.sizeType
};
var defaultRenderMenu = function defaultRenderMenu(results, menuProps, props) {
  return /*#__PURE__*/_react["default"].createElement(_TypeaheadMenu["default"], (0, _extends2["default"])({}, menuProps, {
    labelKey: props.labelKey,
    options: results,
    text: props.text
  }));
};
var defaultRenderToken = function defaultRenderToken(option, props, idx) {
  return /*#__PURE__*/_react["default"].createElement(_Token["default"], {
    disabled: props.disabled,
    key: idx,
    onRemove: props.onRemove,
    option: option,
    tabIndex: props.tabIndex
  }, (0, _utils.getOptionLabel)(option, props.labelKey));
};
function Typeahead(props) {
  var children = props.children,
    clearButton = props.clearButton,
    disabled = props.disabled,
    emptyLabel = props.emptyLabel,
    isLoading = props.isLoading,
    id = props.id,
    isInvalid = props.isInvalid,
    isValid = props.isValid,
    maxHeight = props.maxHeight,
    multiple = props.multiple,
    newSelectionPrefix = props.newSelectionPrefix,
    paginationText = props.paginationText,
    renderMenuItemChildren = props.renderMenuItemChildren,
    results = props.results,
    size = props.size;
  var rootElementRef = (0, _useRootClose["default"])(props.hideMenu, {
    disabled: props.open || !props.isMenuShown
  });
  var _useState = (0, _react.useState)(null),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    referenceElement = _useState2[0],
    setReferenceElement = _useState2[1];

  // Menu
  var overlayProps = (0, _Overlay.useOverlay)(referenceElement, props);
  var renderMenu = props.renderMenu || defaultRenderMenu;
  var menuProps = _objectSpread(_objectSpread({}, overlayProps), {}, {
    emptyLabel: emptyLabel,
    id: id,
    maxHeight: maxHeight,
    newSelectionPrefix: newSelectionPrefix,
    paginationText: paginationText,
    renderMenuItemChildren: renderMenuItemChildren
  });
  function renderInput() {
    var inputProps = _objectSpread(_objectSpread({}, props.getInputProps(props.inputProps)), {}, {
      referenceElementRef: setReferenceElement
    });
    if (props.renderInput) {
      return props.renderInput(inputProps, props);
    }
    var commonProps = _objectSpread(_objectSpread({}, inputProps), {}, {
      isInvalid: isInvalid,
      isValid: isValid,
      size: size
    });
    if (!multiple) {
      return /*#__PURE__*/_react["default"].createElement(_TypeaheadInputSingle["default"], commonProps);
    }
    var labelKey = props.labelKey,
      onRemove = props.onRemove,
      selected = props.selected;
    var renderToken = props.renderToken || defaultRenderToken;
    var tokenProps = _objectSpread(_objectSpread({}, commonProps), {}, {
      labelKey: labelKey,
      onRemove: onRemove
    });
    return /*#__PURE__*/_react["default"].createElement(_TypeaheadInputMulti["default"], (0, _extends2["default"])({}, commonProps, {
      placeholder: selected.length ? '' : inputProps.placeholder,
      selected: selected
    }), selected.map(function (option, idx) {
      return renderToken(option, tokenProps, idx);
    }));
  }
  var auxContent;
  if (isLoading) {
    auxContent = /*#__PURE__*/_react["default"].createElement(_Loader["default"], null);
  } else if (clearButton && !disabled && props.selected.length) {
    auxContent = /*#__PURE__*/_react["default"].createElement(_ClearButton["default"], {
      onClick: props.onClear,
      onMouseDown: _utils.preventInputBlur,
      size: size
    });
  }
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])('rbt', {
      'has-aux': !!auxContent,
      'is-invalid': props.isInvalid,
      'is-valid': props.isValid
    }, props.className),
    ref: rootElementRef,
    style: _objectSpread(_objectSpread({}, props.style), {}, {
      outline: 'none',
      position: 'relative'
    }),
    tabIndex: -1
  }, renderInput(), props.isMenuShown && renderMenu(results, menuProps, props), auxContent && /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])('rbt-aux', {
      'rbt-aux-lg': (0, _utils.isSizeLarge)(size)
    })
  }, auxContent), (0, _utils.isFunction)(children) ? children(props) : children);
}
Typeahead.propTypes = propTypes;
var TypeaheadExport = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var typeaheadProps = (0, _useTypeahead["default"])(props, ref);
  return /*#__PURE__*/_react["default"].createElement(_TypeaheadManager["default"], typeaheadProps, function (managerProps) {
    return /*#__PURE__*/_react["default"].createElement(Typeahead, (0, _extends2["default"])({}, props, managerProps));
  });
});
var _default = exports["default"] = TypeaheadExport;