"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _Context = require("./Context");
var _utils = require("../utils");
var TypeaheadManager = function TypeaheadManager(props) {
  var activeIndex = props.activeIndex,
    children = props.children,
    id = props.id,
    isMenuShown = props.isMenuShown,
    onKeyDown = props.onKeyDown;
  var childProps = {
    getInputProps: (0, _utils.getInputProps)({
      activeIndex: activeIndex,
      disabled: props.disabled,
      id: id,
      inputRef: props.inputRef,
      isFocused: props.isFocused,
      isMenuShown: isMenuShown,
      multiple: props.multiple,
      onBlur: props.onBlur,
      onChange: props.onChange,
      onClick: props.onClick,
      onFocus: props.onFocus,
      onKeyDown: onKeyDown,
      placeholder: props.placeholder,
      value: (0, _utils.getInputText)(props)
    }),
    hideMenu: props.hideMenu,
    isMenuShown: isMenuShown,
    labelKey: props.labelKey,
    onClear: props.onClear,
    onHide: props.onHide,
    onRemove: props.onRemove,
    results: props.results,
    selected: props.selected,
    text: props.text,
    toggleMenu: props.toggleMenu
  };
  var contextValue = {
    activeIndex: activeIndex,
    hintText: props.hintText,
    id: id,
    initialItem: props.initialItem,
    inputNode: props.inputNode,
    isOnlyResult: props.isOnlyResult,
    onAdd: props.onAdd,
    onInitialItemChange: props.onInitialItemChange,
    onMenuItemClick: props.onMenuItemClick,
    setItem: props.setItem
  };
  return /*#__PURE__*/_react["default"].createElement(_Context.TypeaheadContext.Provider, {
    value: contextValue
  }, (0, _utils.isFunction)(children) ? children(childProps) : children);
};
var _default = exports["default"] = TypeaheadManager;