import PropTypes from 'prop-types';
import React, { forwardRef } from 'react';
import useAsync from '../../core/useAsync';
import Typeahead from '../Typeahead';
const AsyncTypeahead = forwardRef((props, ref) => {
    return React.createElement(Typeahead, { ...useAsync(props), ref: ref });
});
AsyncTypeahead.propTypes = {
    delay: PropTypes.number,
    isLoading: PropTypes.bool.isRequired,
    minLength: PropTypes.number,
    onSearch: PropTypes.func.isRequired,
    promptText: PropTypes.node,
    searchText: PropTypes.node,
    useCache: PropTypes.bool,
};
export default AsyncTypeahead;
