import PropTypes from 'prop-types';
import React, { HTMLAttributes } from 'react';
import { UseItemProps } from '../../core/useItem';
export interface BaseMenuItemProps extends HTMLAttributes<HTMLAnchorElement> {
    active?: boolean;
    disabled?: boolean;
    href?: string;
}
export declare const BaseMenuItem: React.ForwardRefExoticComponent<BaseMenuItemProps & React.RefAttributes<HTMLAnchorElement>>;
export type MenuItemProps = UseItemProps<HTMLAnchorElement>;
declare function MenuItem(props: MenuItemProps): React.JSX.Element;
declare namespace MenuItem {
    var propTypes: {
        option: PropTypes.Validator<NonNullable<NonNullable<string | object | null | undefined>>>;
        position: PropTypes.Requireable<number>;
    };
}
export default MenuItem;
