import cx from 'classnames';
import PropTypes from 'prop-types';
import React, { forwardRef } from 'react';
import useItem from '../../core/useItem';
import { optionType } from '../../propTypes';
export const BaseMenuItem = forwardRef(({ active, children, className, disabled, onClick, ...props }, ref) => {
    return (React.createElement("a", { ...props, className: cx('dropdown-item', { active, disabled }, className), href: props.href || '#', onClick: (e) => {
            e.preventDefault();
            !disabled && onClick && onClick(e);
        }, ref: ref }, children));
});
function MenuItem(props) {
    return React.createElement(BaseMenuItem, { ...useItem(props) });
}
MenuItem.propTypes = {
    option: optionType.isRequired,
    position: PropTypes.number,
};
export default MenuItem;
