import PropTypes from 'prop-types';
import React from 'react';
import { UseTokenProps } from '../../core/useToken';
export interface TokenProps<T> extends UseTokenProps<T> {
    disabled?: boolean;
    readOnly?: boolean;
}
declare const Token: {
    ({ children, option, readOnly, ...props }: TokenProps<HTMLElement>): React.JSX.Element;
    propTypes: {
        onBlur: PropTypes.Requireable<(...args: any[]) => any>;
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        onFocus: PropTypes.Requireable<(...args: any[]) => any>;
        onRemove: PropTypes.Requireable<(...args: any[]) => any>;
        option: PropTypes.Validator<NonNullable<NonNullable<string | object | null | undefined>>>;
    };
};
export default Token;
