import React, { CSSProperties, ReactNode } from 'react';
import { TypeaheadRef } from '../../core/useTypeahead';
import { RenderMenuItemChildren } from '../TypeaheadMenu';
import { MenuProps } from '../Menu';
import { Align, Option, RenderToken, Size, TypeaheadInputProps, TypeaheadProps, TypeaheadManagerChildProps } from '../../types';
export interface RenderMenuProps extends MenuProps {
    newSelectionPrefix?: ReactNode;
    paginationText?: ReactNode;
    renderMenuItemChildren?: RenderMenuItemChildren;
}
export interface TypeaheadComponentProps extends Partial<TypeaheadProps> {
    align?: Align;
    className?: string;
    clearButton?: boolean;
    disabled?: boolean;
    dropup?: boolean;
    emptyLabel?: ReactNode;
    flip?: boolean;
    isInvalid?: boolean;
    isLoading?: boolean;
    isValid?: boolean;
    maxHeight?: string;
    newSelectionPrefix?: ReactNode;
    options: Option[];
    paginationText?: ReactNode;
    placeholder?: string;
    positionFixed?: boolean;
    renderInput?: (inputProps: TypeaheadInputProps, props: TypeaheadManagerChildProps) => JSX.Element;
    renderMenu?: (results: Option[], menuProps: RenderMenuProps, state: TypeaheadManagerChildProps) => JSX.Element;
    renderMenuItemChildren?: RenderMenuItemChildren;
    renderToken?: RenderToken;
    size?: Size;
    style?: CSSProperties;
}
declare const TypeaheadExport: React.ForwardRefExoticComponent<TypeaheadComponentProps & React.RefAttributes<TypeaheadRef>>;
export default TypeaheadExport;
