import React, { Ref } from 'react';
import { FilterByCallback, Option, SelectEvent, TypeaheadProps } from '../types';
export interface TypeaheadRef {
    blur: () => void;
    clear: () => void;
    focus: () => void;
    getInput: () => void;
    hideMenu: () => void;
    toggleMenu: () => void;
}
interface Props extends Partial<TypeaheadProps> {
    options: Option[];
}
declare function useTypeahead({ onChange, ...partialProps }: Props, ref: Ref<TypeaheadRef>): {
    hideMenu: () => void;
    hintText: string;
    inputNode: HTMLInputElement | null;
    inputRef: React.Dispatch<React.SetStateAction<HTMLInputElement | null>>;
    isMenuShown: boolean;
    isOnlyResult: boolean;
    onAdd: (option: Option) => void;
    onBlur: (e: React.FocusEvent<HTMLInputElement>) => void;
    onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onClear: () => void;
    onClick: (e: React.MouseEvent<HTMLInputElement>) => void;
    onFocus: (e: React.SyntheticEvent<HTMLInputElement>) => void;
    onHide: () => void;
    onInitialItemChange: (initialItem?: Option) => void;
    onKeyDown: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    onMenuItemClick: (option: Option, e: SelectEvent<HTMLElement>) => void;
    onRemove: (selection: Option) => void;
    results: Option[];
    setItem: (item: Option, position: number) => void;
    toggleMenu: () => void;
    activeIndex: number;
    activeItem?: Option | undefined;
    initialItem?: Option | undefined;
    isFocused: boolean;
    selected: Option[];
    showMenu: boolean;
    shownResults: number;
    text: string;
    allowNew: import("../types").AllowNew;
    autoFocus: boolean;
    caseSensitive: boolean;
    children?: import("../types").TypeaheadChildren;
    defaultInputValue: string;
    defaultOpen: boolean;
    defaultSelected: Option[];
    emptyLabel?: React.ReactNode;
    filterBy: FilterByCallback | string[];
    highlightOnlyResult: boolean;
    id?: string | undefined;
    ignoreDiacritics: boolean;
    inputProps?: import("../types").InputProps | undefined;
    labelKey: import("../types").LabelKey;
    maxResults: number;
    minLength: number;
    multiple: boolean;
    onInputChange: (text: string, event: React.ChangeEvent<HTMLInputElement>) => void;
    onMenuToggle: (isOpen: boolean) => void;
    onPaginate: (event: SelectEvent<HTMLElement>, shownResults: number) => void;
    open?: boolean | undefined;
    options: Option[];
    paginate: boolean;
    selectHint?: import("../types").SelectHint | undefined;
};
export default useTypeahead;
