/// <reference types="react" />
import { TypeaheadManagerProps } from '../types';
interface Args extends Pick<TypeaheadManagerProps, 'activeIndex' | 'id' | 'inputRef' | 'isFocused' | 'isMenuShown' | 'multiple' | 'onBlur' | 'onChange' | 'onClick' | 'onFocus' | 'onKeyDown' | 'placeholder'> {
    disabled?: boolean;
    value: string;
}
declare const getInputProps: ({ activeIndex, id, isFocused, isMenuShown, multiple, onClick, onFocus, placeholder, ...props }: Args) => (inputProps?: {}) => {
    onClick: import("react").MouseEventHandler<HTMLInputElement>;
    onFocus: (event: import("react").SyntheticEvent<HTMLInputElement, Event>) => void;
    role: string;
    inputClassName?: string | undefined;
    'aria-activedescendant': string | undefined;
    'aria-autocomplete': "both";
    'aria-expanded': boolean;
    'aria-haspopup': "listbox";
    'aria-multiselectable': true | undefined;
    'aria-owns': string | undefined;
    className: string;
    disabled?: boolean | undefined;
    value: string;
    onChange: import("react").ChangeEventHandler<HTMLInputElement>;
    onBlur: import("react").FocusEventHandler<HTMLInputElement>;
    onKeyDown: import("react").KeyboardEventHandler<HTMLInputElement>;
    inputRef: (instance: HTMLInputElement | null) => void;
    autoComplete: string;
    placeholder: string | undefined;
    type: string;
};
export default getInputProps;
